"use strict";
	
	function switchToGroup(e, groupName) {
		
		let arr = e._groupsByName.get(groupName);
		
		arr._subEvents.forEach(function(element){
			element._isGroupActive = false;
		});
		
		arr._isGroupActive = true;
		
	}
	
	function groupAvailable(rt, g){
		if (rt.GetRuntime().GetEventSheetManager()._groupsByName.get(g) === undefined){
			return false;
		}
		return true;
	}

{
	
	C3.Plugins.wackytoasterGroupHandler.Acts =
	{
		
		disableSubgroupsOf(groupName)
		{
			
			if (!groupAvailable(this, groupName)){
				console.warn("Unable to find specified group name");
			} else {
				this.arr = this.GetRuntime().GetEventSheetManager()._groupsByName.get(groupName)._subEvents;
			
				this.arr.forEach(function(element){
					element._isGroupActive = false;
				});
			}
			
		},
		
		enableSubgroupsOf(groupName)
		{
			
			if (!groupAvailable(this, groupName)){
				console.warn("Unable to find specified group name");
			} else {
				this.arr = this.GetRuntime().GetEventSheetManager()._groupsByName.get(groupName)._subEvents;
			
				this.arr.forEach(function(element){
					element._isGroupActive = true;
				});
			}
			
		},
		
		enableGroup(groupName){
			
			if (!groupAvailable(this, groupName)){
				console.warn("Unable to find specified group name");
			} else {
				this.arr = this.GetRuntime().GetEventSheetManager()._groupsByName.get(groupName);
				this.arr._isGroupActive = true;
			}
			
		},
		
		disableGroup(groupName){
			
			if (!groupAvailable(this, groupName)){
				console.warn("Unable to find specified group name");
			} else {
				this.arr = this.GetRuntime().GetEventSheetManager()._groupsByName.get(groupName);
				this.arr._isGroupActive = false;
			}
			
		},
		
		enableGroupsOfType(groupType) {
			
			this.arr = Array.from(this.GetRuntime().GetEventSheetManager()._groupsByName);
			
			this.arr.forEach((element) => {
				if (element[1]._groupName.includes(groupType)){
					element[1]._isGroupActive = true;
				}
			});
		
		},
		
		disableGroupsOfType(groupType) {
			
			this.arr = Array.from(this.GetRuntime().GetEventSheetManager()._groupsByName);
			
			this.arr.forEach((element) => {
				if (element[1]._groupName.includes(groupType)){
					element[1]._isGroupActive = false;
				}
			});
		
		},
		
		switchToGroup(groupName)
		{
			
			if (!groupAvailable(this, groupName)){
				alert("Unable to find specified group name");
			} else {
				
				this.arr = this.GetRuntime().GetEventSheetManager()._groupsByName.get(groupName);
				
				if (this.arr._parent !== null && this.arr._parent !== undefined){
					this.arr._parent._subEvents.forEach(function(element){
						element._isGroupActive = false;
					});
				
					this.arr._isGroupActive = true;
				} else {
					console.warn("switchToGroup", "Specified group has no parent group.");
				}
				
			}
			
		},
		
		disableThisGroup()
		{
				
			this.arr = this.GetRuntime().GetEventSheetManager().GetCurrentEvent()._parent;
			
			if (this.arr !== null && this.arr !== undefined){
				this.arr._isGroupActive = false;
			} else {
				console.warn("disableThisGroup", "Action is not inside a group.");
			}
			
		}
		
	}
		
}